/****************************************************************************
 ** Makou Reactor Final Fantasy VII Field Script Editor
 ** Copyright (C) 2009-2012 Arzel Jrme <myst6re@gmail.com>
 **
 ** This program is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ****************************************************************************/
#ifndef DEF_TEXTE
#define DEF_TEXTE

#include <QtCore>
#include "Config.h"

class Texte
{
public:
	Texte(const QByteArray &texte=QByteArray());
	Texte(const QString &texte);
	const QByteArray &getData() const;
	QString getText(bool simplified=false) const;
	QString getShortText() const;
	void setText(const QString &text);
	bool search(const QRegExp &texte) const;

private:
	QString getCaract(quint8 ord, quint8 table=0) const;
	static const char *caract[256];
	static const char *caract_jp[256];
	static const char *caract_jp_fa[256];
	static const char *caract_jp_fb[256];
	static const char *caract_jp_fc[256];
	static const char *caract_jp_fd[256];
	static const char *caract_jp_fe[256];
	QByteArray texte;
};

#endif
