/****************************************************************************
 ** Makou Reactor Final Fantasy VII Field Script Editor
 ** Copyright (C) 2009-2012 Arzel Jrme <myst6re@gmail.com>
 **
 ** This program is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ****************************************************************************/
#ifndef DEF_VAR
#define DEF_VAR

#include <QtGui>
#include "Texte.h"
#include "LZS.h"
#include "Opcode.h"
#include "Config.h"

class Var
{
public:
	static int load();
	static int save(const QMap<quint16, QString> &);
	static QString name(quint8 bank, quint8 adress);
	static const QMap<quint16, QString> &get();
	static void set(quint8 bank, quint8 adress, const QString &name);
	static void del(quint8 bank, quint8 adress);
	static bool exists(quint8 bank, quint8 adress);

private:
	static QMap<quint16, QString> var_names;
};

class Data
{
public:
	static const QString &ff7DataPath();
	static const QString &ff7AppPath();
	static QString charlgp_path();
	static void charlgp_loadListPos(QFile *);
	static void charlgp_loadAnimBoneCount();
	static QHash<QString, int> charlgp_listPos;
	static QHash<QString, int> charlgp_animBoneCount;
	static int load();
	static void openMaplist(const QByteArray &data);
	static void openMaplist(bool PC=false);
	static QStringList char_names;
	static QStringList operateur_names;
	static QStringList key_names;
	static QStringList item_names;
	static QStringList weapon_names;
	static QStringList armor_names;
	static QStringList accessory_names;
	static QStringList materia_names;
	static const QList<Texte *> *currentTextes;
	static QStringList currentGrpScriptNames;
//	static QStringList currentCharNames;
	static int currentModelID;
	static QStringList *currentHrcNames;
	static QList<QStringList> *currentAnimNames;
	static QStringList field_names;
	static QStringList movie_names;
	static QList<Opcode> opcodes;

private:
	static void fill(const QByteArray &data, QStringList &names);
	static QString ff7DataPath_cache;
	static QString ff7AppPath_cache;

};

#endif
