/****************************************************************************
 ** Makou Reactor Final Fantasy VII Field Script Editor
 ** Copyright (C) 2009-2012 Arzel Jrme <myst6re@gmail.com>
 **
 ** This program is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ****************************************************************************/
#include <QApplication>
#include "Window.h"
#include "Var.h"

int main(int argc, char *argv[])
{
	QGLFormat::setDefaultFormat(QGLFormat(QGL::DirectRendering));

	QApplication app(argc, argv);
	app.setWindowIcon(QIcon(":/images/logo-shinra.png"));

	Config::set();

	QString lang = Config::value("lang", QLocale::system().name()).toString();
	QTranslator translator1;
	if(translator1.load("qt_" % lang, app.applicationDirPath()) || translator1.load("qt_" % lang, QLibraryInfo::location(QLibraryInfo::TranslationsPath)))
		app.installTranslator(&translator1);
	QTranslator translator2;
	if(translator2.load("Makou_Reactor_" % lang, app.applicationDirPath()))
		app.installTranslator(&translator2);
	else
		Config::setValue("lang", "fr");
	
	if(Var::load()==1)
	{
		QMessageBox::warning(0, QObject::tr("Erreur"), QObject::tr("Le fichier 'var.cfg' n'a pas pu tre charg.\nVrifiez que ce fichier est valide ou supprimez-le."));
	}
	Data::load();
	
	Window fenetre;
	fenetre.show();
	if(argc>1)
		fenetre.ouvrir(argv[1]);

//	Config::setValue("jp_txt", true);
	/*for(int i=0 ; i<255 ; ++i) {
		for(int j=0 ; j<255 ; ++j) {
			for(int k=0 ; k<255 ; ++k) {
				qDebug() << i << j << k;
				for(int l=0 ; l<255 ; ++l) {
					QByteArray base = QByteArray().append((char)i).append((char)j).append((char)k).append((char)l);
					Texte t(base);
					QString text = t.getText();
					t.setText(text);
					if(base != t.getData()) {
						qDebug() << "Erreur" << base.toHex() << t.getData().toHex() << text;
						return app.exec();
					}
				}
			}
		}
	}*/

//	QFile f("C:/Users/vista/Documents/Makou_Reactor/data/WINDOW.BIN/windowPC.3.bin");
//	f.open(QIODevice::ReadOnly);
//	QByteArray data = f.readAll();
//	QString out;

//	int start = 231+210+231+210+210, len = 210;

//	for(int i=start ; i<start+256 ; ++i) {
//		if(i<start+len)
//			out.append(QString("%1, ").arg((int)data.at(i)));
//		else
//			out.append(QString("0, "));
//		if((i+1-start) % 16 == 0) {
//			out.append("\n");
//		}
//	}

//	qDebug() << out;

	return app.exec();
}
